#ifndef JS_EXTENSION_DATA_H
#define JS_EXTENSION_DATA_H

#include <APICast.h>
#include <JSObjectRef.h>
#include "JSEventSystem.h"
#include <string>
#include <stack>

struct JSEventListenerData{
	std::string eventName;
	JSContextRef functionContext;
	JSObjectRef function;
	JSObjectRef scopeObj;
};

class JSExtensionEventListener : public JSEventListener
{
public:
	JSExtensionEventListener(std::string listener_name);
	/**
	@brief Adds listener callback data.  This is called when a JSExtension adds an event listener.
	*/
	virtual void AddListenerCallback(JSEventListenerData* callback);

	/**
	@brief Adds listener callback data.  This is called when a JSExtension adds an event listener.
	*/
	virtual void RemoveListenerCallback(JSEventListenerData callback);

	/**
	@brief Deletes all added listener callbacks.
	*/
	virtual void ClearListenerCallbacks(void);

protected:
	std::vector<JSEventListenerData*> listener_callbacks;
};


struct JSExtensionData{
	int indexID;
	JSExtensionEventListener* eventListener;
	JSEventDispatcher* eventDispatcher;
};
#endif
