#ifndef _FFMPEG_FFT_WIIU_INTERNAL_H_
#define _FFMPEG_FFT_WIIU_INTERNAL_H_

#ifdef __cplusplus
extern "C"
{
#endif


typedef struct _ffmpeg_fft_mem_fn_wiiu {
	void	*(*Allocate)(unsigned int);
	void	*(*AllocateAligned)(unsigned int, unsigned int);
	void	(*Deallocate)(void *);
	void	*(*Reallocate)(void *, unsigned int);
} ffmpeg_fft_mem_fn_wiiu;

typedef struct _ffmpeg_fft_init_config_wiiu {
	ffmpeg_fft_mem_fn_wiiu		mpMemCallbacks;
} ffmpeg_fft_init_config_wiiu;

int _ffmpeg_FFT_Init_WiiU(const ffmpeg_fft_init_config_wiiu *pConfig);
void _ffmpeg_FFT_Exit_WiiU(void);

int _ffmpeg_FFT_Create_WiiU(void **ppHandle, int nPow2Bits);
int _ffmpeg_FFT_Destroy_WiiU(void *pHandle);

void _ffmpeg_FFT_CalcForward_WiiU(void *pHandle, float *pInOutData);
void _ffmpeg_FFT_CalcInverse_WiiU(void *pHandle, float *pInOutData);


#ifdef __cplusplus
};
#endif


#endif

