#ifndef DEBUGIO_H
#define DEBUGIO_H

namespace LibPlatform {
	class DebugIO {
	public:
		typedef signed Handle;
		typedef signed Status;
		typedef unsigned ChannelOptions;
		typedef unsigned ChannelFlags;

		static Handle Open(
			const char *hio_name,
			void (*connection_callback)(Status status, void *context),
			void *context,
			ChannelOptions options,
			ChannelFlags flags
		);

		static Status ReadAsync(
			Handle handle, 
			unsigned size_in_bytes, 
			void *data, 
			void (*async_param)(Status status, void *context),
			void *context
		);

		static Status WriteAsync(
			Handle handle, 
			unsigned size_in_bytes, 
			void *data,
			void (*async_param)(Status status, void *context),
			void *context
		);

		static Status Write(
			Handle handle, 
			unsigned sizeInBytes, 
			const void *data
		);

		static Status Close(Handle handle);
	};
}

#endif//DEBUGIO_H