
#ifndef PLATFORMMEMORY_H
#define PLATFORMMEMORY_H

#include <cstring> // for size_t

namespace LibPlatform {
	class Memory {
	public:
		typedef void *HeapHandle;

		static void *Copy(void *destination, const void *source, size_t num);
		static void SetUsageHeapAllocators(void*(*allocFuncP)(int, unsigned int, signed int), void(*freeFuncP)(void *));

		static HeapHandle CreateExpHeap(void *start_address, unsigned size);
		static void *AllocFromExpHeap(HeapHandle heap_handle, unsigned size);
		static void *AllocFromExpHeapEx(HeapHandle heap_handle, unsigned size, signed alignment);
		static void *AllocFromDefaultHeap(unsigned size);
		static void *AllocFromDefaultHeapEx(unsigned size, signed alignment);
		static void* AllocFromUsageHeap(int usage, unsigned size, signed alignment);
		static void FreeToExpHeap(HeapHandle heap_handle, void *mem_block);
		static void FreeToDefaultHeap(void *mem_block);
		static void FreeToUsageHeap(void *mem_block);
		static void *DestroyExpHeap(HeapHandle heap_handle);
		static HeapHandle GetBaseHeapHandleArena1(void);
		static HeapHandle GetBaseHeapHandleArena2(void);
		static void DumpHeap(HeapHandle heap_handle);
		static signed GetHeapTotalSize(HeapHandle heap_handle);
		static signed GetHeapTotalUsableSize(HeapHandle heap_handle);
		static unsigned GetPPCIOBufferAlign(void);
	};
}

#endif//PLATFORMMEMORY_H
