/*

	LibShim Startup/Shutdown/Utilities

	Include

*/

#ifndef _SHIM_H_
#define _SHIM_H_

#ifdef __cplusplus
extern "C" {
#endif

extern void shim_Init(void);
extern void shim_Exit(void);

extern void shim_SetStorageWaitReadyCallback(int (*WaitForStorageReady)());

extern void* shim_GetFSClient(void);
extern int shim_GetFSMaxArgPathSize();
extern int shim_GetFSMaxFullPathSize();
extern int shim_GetFSMaxEntNameSize();

#define SHIM_FS_CLIENT_MAX_NAME		32
typedef struct SHIMfsClient_t
	{
	void	*mpFSClient;
	char	maClientName[SHIM_FS_CLIENT_MAX_NAME];
	} SHIMfsClient;

extern int shim_GetAllFSClients(SHIMfsClient *paOutClients, int maxOutClients);

#define SHIM_FS_FILE_MAX_NAME		512

typedef struct SHIMfsErrorInfo_t {
		int		m_fsErrorCode;
		int		m_dispErrorCode;
		char	m_fileName[SHIM_FS_FILE_MAX_NAME];
} SHIMfsErrorInfo;

#define SHIM_SO_HOST_MAX_NAME		512

typedef struct SHIMsoErrorInfo_t {
		int		m_soErrorCode;
		int		m_dispErrorCode;
		char	m_hostName[SHIM_SO_HOST_MAX_NAME];
} SHIMsoErrorInfo;

extern SHIMfsErrorInfo *shim_GetFSError(void);
extern int shim_HasFSError(void);

extern SHIMsoErrorInfo *shim_GetSOError(void);
extern int shim_HasSOError(void);

extern const char *shim_GetLanguage(void);

#ifdef __cplusplus
}
#endif

#endif // _SHIM_H_




